.\"	$NetBSD: mly.4,v 1.9 2006/11/13 16:33:57 ad Exp $
.\"
.\" Copyright (c) 2001 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Andrew Doran.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\" Copyright (c) 2000 Michael Smith
.\" Copyright (c) 2000 BSDi
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" from FreeBSD: mly.4,v 1.6 2001/07/14 19:40:47 schweikh Exp
.\"
.Dd July 29, 2001
.Dt MLY 4
.Os
.Sh NAME
.Nm mly
.Nd Mylex AcceleRAID/eXtremeRAID family driver
.Sh SYNOPSIS
.Cd "mly* at pci? dev ? function ?"
.Cd "scsibus* at mly?"
.Sh DESCRIPTION
The
.Nm
driver provides support for Mylex AcceleRAID and eXtremeRAID family
of PCI to SCSI RAID controllers with version 6.00 and later
firmware.
Supported controllers include:
.Pp
.Bl -bullet -compact
.It
AcceleRAID 160
.It
AcceleRAID 170
.It
AcceleRAID 352
.It
eXtremeRAID 2000
.It
eXtremeRAID 3000
.El
.Pp
Compatible Mylex controllers not listed should work, but have not been
tested.
.Pp
Logical devices (disk arrays) attached to the controller are presented
to the SCSI subsystem as though they were direct-access devices on a
virtual SCSI bus.
Physical devices which are not claimed by a logical
device are presented on SCSI channels which match the physical channels
on the controller.
.Pp
The results of the SCSI ``INQUIRY'' command from logical devices are
overwritten with status information by the
.Nm
driver.  The vendor field is the string ``MYLEX'', the product field
indicates the type of logical device, and the revision field contains a four
letter status code.  The possible status codes and their meanings are as
follows:
.Pp
.Bl -tag -width XXXX -compact
.It OFLN
offline
.It UNCF
unconfigured
.It ONLN
online - optimal
.It CRIT
critical - one or more disks in the array has failed
.It NORD
write only
.It STBY
standby
.It MISS
missing
.El
.Sh DIAGNOSTICS
.Ss Controller initialization phase
.Bl -diag
.It "mly%d: controller initialization started"
.It "mly%d: initialization complete"
.Pp
The controller firmware has started initialization.
Normally this process is performed by the controller BIOS,
but the driver may need
to do this in cases where the BIOS has failed, or is not compatible
(e.g. on non-x86 systems).
.It "mly%d: drive spinup in progress"
.Pp
Drive startup is in progress; this may take several minutes.
.It "mly%d: mirror race recovery failed, one or more drives offline"
.It "mly%d: mirror race recovery in progress"
.It "mly%d: mirror race recovery on a critical drive"
.Pp
These error codes are undocumented.
.It "mly%d: FATAL MEMORY PARITY ERROR"
.Pp
Firmware detected a fatal memory error; the driver will not attempt to
attach to this controller.
.It "mly%d: unknown initialization code %x"
.Pp
An unknown error occurred during initialization; it will be ignored.
.El
.Ss Operational diagnostics
.Bl -diag
.It "mly%d: physical device %d:%d online"
.It "mly%d: physical device %d:%d standby"
.It "mly%d: physical device %d:%d automatic rebuild started"
.It "mly%d: physical device %d:%d manual rebuild started"
.It "mly%d: physical device %d:%d rebuild completed"
.It "mly%d: physical device %d:%d rebuild cancelled"
.It "mly%d: physical device %d:%d rebuild failed for unknown reasons"
.It "mly%d: physical device %d:%d rebuild failed due to new physical device"
.It "mly%d: physical device %d:%d rebuild failed due to logical drive failure"
.It "mly%d: physical device %d:%d found"
.It "mly%d: physical device %d:%d gone"
.It "mly%d: physical device %d:%d unconfigured"
.It "mly%d: physical device %d:%d expand capacity started"
.It "mly%d: physical device %d:%d expand capacity completed"
.It "mly%d: physical device %d:%d expand capacity failed"
.It "mly%d: physical device %d:%d parity error"
.It "mly%d: physical device %d:%d soft error"
.It "mly%d: physical device %d:%d miscellaneous error"
.It "mly%d: physical device %d:%d reset"
.It "mly%d: physical device %d:%d active spare found"
.It "mly%d: physical device %d:%d warm spare found"
.It "mly%d: physical device %d:%d initialization started"
.It "mly%d: physical device %d:%d initialization completed"
.It "mly%d: physical device %d:%d initialization failed"
.It "mly%d: physical device %d:%d initialization cancelled"
.It "mly%d: physical device %d:%d write recovery failed"
.It "mly%d: physical device %d:%d scsi bus reset failed"
.It "mly%d: physical device %d:%d double check condition"
.It "mly%d: physical device %d:%d device cannot be accessed"
.It "mly%d: physical device %d:%d gross error on scsi processor"
.It "mly%d: physical device %d:%d bad tag from device"
.It "mly%d: physical device %d:%d command timeout"
.It "mly%d: physical device %d:%d system reset"
.It "mly%d: physical device %d:%d busy status or parity error"
.It "mly%d: physical device %d:%d host set device to failed state"
.It "mly%d: physical device %d:%d selection timeout"
.It "mly%d: physical device %d:%d scsi bus phase error"
.It "mly%d: physical device %d:%d device returned unknown status"
.It "mly%d: physical device %d:%d device not ready"
.It "mly%d: physical device %d:%d device not found at startup"
.It "mly%d: physical device %d:%d COD write operation failed"
.It "mly%d: physical device %d:%d BDT write operation failed"
.It "mly%d: physical device %d:%d missing at startup"
.It "mly%d: physical device %d:%d start rebuild failed due to physical drive too small"
.It "mly%d: physical device %d:%d sense data received"
.It "mly%d:   sense key %d  asc %02x  ascq %02x"
.It "mly%d:   info %4D  csi %4D"
.It "mly%d: physical device %d:%d offline"
.It "mly%d:   sense key %d  asc %02x  ascq %02x"
.It "mly%d:   info %4D  csi %4D"
.Pp
The reported event refers to the physical device at the given channel:target
address.
.It "mly%d: logical device %d:%d consistency check started"
.It "mly%d: logical device %d:%d consistency check completed"
.It "mly%d: logical device %d:%d consistency check cancelled"
.It "mly%d: logical device %d:%d consistency check completed with errors"
.It "mly%d: logical device %d:%d consistency check failed due to logical drive failure"
.It "mly%d: logical device %d:%d consistency check failed due to physical device failure"
.It "mly%d: logical device %d:%d automatic rebuild started"
.It "mly%d: logical device %d:%d manual rebuild started"
.It "mly%d: logical device %d:%d rebuild completed"
.It "mly%d: logical device %d:%d rebuild cancelled"
.It "mly%d: logical device %d:%d rebuild failed for unknown reasons"
.It "mly%d: logical device %d:%d rebuild failed due to new physical device"
.It "mly%d: logical device %d:%d rebuild failed due to logical drive failure"
.It "mly%d: logical device %d:%d offline"
.It "mly%d: logical device %d:%d critical"
.It "mly%d: logical device %d:%d online"
.It "mly%d: logical device %d:%d initialization started"
.It "mly%d: logical device %d:%d initialization completed"
.It "mly%d: logical device %d:%d initialization cancelled"
.It "mly%d: logical device %d:%d initialization failed"
.It "mly%d: logical device %d:%d found"
.It "mly%d: logical device %d:%d gone"
.It "mly%d: logical device %d:%d expand capacity started"
.It "mly%d: logical device %d:%d expand capacity completed"
.It "mly%d: logical device %d:%d expand capacity failed"
.It "mly%d: logical device %d:%d bad block found"
.It "mly%d: logical device %d:%d size changed"
.It "mly%d: logical device %d:%d type changed"
.It "mly%d: logical device %d:%d bad data block found"
.It "mly%d: logical device %d:%d read of data block in bdt"
.It "mly%d: logical device %d:%d write back data for disk block lost"
.Pp
The reported event refers to the logical device at the given channel:target
address.
.\" The event report will include the name of the SCSI device which has
.\" attached to the device if possible.
.It "mly%d: enclosure %d fan %d failed"
.It "mly%d: enclosure %d fan %d ok"
.It "mly%d: enclosure %d fan %d not present"
.It "mly%d: enclosure %d power supply %d failed"
.It "mly%d: enclosure %d power supply %d ok"
.It "mly%d: enclosure %d power supply %d not present"
.It "mly%d: enclosure %d temperature sensor %d failed"
.It "mly%d: enclosure %d temperature sensor %d critical"
.It "mly%d: enclosure %d temperature sensor %d ok"
.It "mly%d: enclosure %d temperature sensor %d not present"
.It "mly%d: enclosure %d unit %d access critical"
.It "mly%d: enclosure %d unit %d access ok"
.It "mly%d: enclosure %d unit %d access offline"
.Pp
These events refer to external enclosures by number.
The driver does not attempt to name the enclosures.
.It "mly%d: controller cache write back error"
.It "mly%d: controller battery backup unit found"
.It "mly%d: controller battery backup unit charge level low"
.It "mly%d: controller battery backup unit charge level ok"
.It "mly%d: controller installation aborted"
.It "mly%d: controller mirror race recovery in progress"
.It "mly%d: controller mirror race on critical drive"
.It "mly%d: controller memory soft ecc error"
.It "mly%d: controller memory hard ecc error"
.It "mly%d: controller battery backup unit failed"
.Pp
These events report controller status changes.
.El
.Sh SEE ALSO
.Xr cd 4 ,
.Xr ch 4 ,
.Xr intro 4 ,
.Xr mlx 4 ,
.Xr scsi 4 ,
.Xr sd 4 ,
.Xr st 4 ,
.Xr scsictl 8
.Sh HISTORY
The
.Nm
driver first appeared in
.Nx 1.6 ,
and was based on the
.Fx
driver of the same name.
.Sh BUGS
The
.Nm
driver currently assumes that all busses support at most 16 targets and 1
logical unit per target.
.Pp
Enclosures are not named or otherwise identified in event messages.
.Pp
The transfer speed for devices is always reported to the kernel as 20MHz.
